Index: LMDZ5/branches/testing/libf/dyn3dpar/gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/gcm.F	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3dpar/gcm.F	(revision 2258)
@@ -24,12 +24,12 @@
 ! Only INCA needs these informations (from the Earth's physics)
       USE indice_sol_mod
+      USE mod_phys_lmdz_omp_data, ONLY: klon_omp 
 #endif
 
 #ifdef CPP_PHYS
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
-      USE mod_phys_lmdz_omp_data, ONLY: klon_omp 
-      USE dimphy
-      USE comgeomphy
+!      USE mod_grid_phy_lmdz
+!      USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
+!      USE dimphy
+!      USE comgeomphy
 #endif
       IMPLICIT NONE
@@ -84,11 +84,4 @@
 #endif
 
-      INTEGER         longcles
-      PARAMETER     ( longcles = 20 )
-      REAL  clesphy0( longcles )
-      SAVE  clesphy0
-
-
-
       REAL zdtvr
 
@@ -112,13 +105,7 @@
 
       LOGICAL lafin
-c      INTEGER ij,iq,l,i,j
-      INTEGER i,j
-
 
       real time_step, t_wrt, t_ops
 
-
-      LOGICAL call_iniphys
-      data call_iniphys/.true./
 
 c+jld variables test conservation energie
@@ -143,17 +130,4 @@
 
 c-----------------------------------------------------------------------
-c    variables pour l'initialisation de la physique :
-c    ------------------------------------------------
-      INTEGER ngridmx
-      PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
-      REAL zcufi(ngridmx),zcvfi(ngridmx)
-      REAL latfi(ngridmx),lonfi(ngridmx)
-      REAL airefi(ngridmx)
-      SAVE latfi, lonfi, airefi
-      
-      INTEGER :: ierr
-
-
-c-----------------------------------------------------------------------
 c   Initialisations:
 c   ----------------
@@ -172,12 +146,7 @@
 c  ---------------------------------------
 c
-! Ehouarn: dump possibility of using defrun
-!#ifdef CPP_IOIPSL
-      CALL conf_gcm( 99, .TRUE. , clesphy0 )
+      CALL conf_gcm( 99, .TRUE. )
       if (mod(iphysiq, iperiod) /= 0) call abort_gcm("conf_gcm",
      s "iphysiq must be a multiple of iperiod", 1)
-!#else
-!      CALL defrun( 99, .TRUE. , clesphy0 )
-!#endif
 c
 c
@@ -193,11 +162,12 @@
 #ifdef CPP_PHYS
         CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
-#endif
+!#endif
+!      CALL set_bands
+!#ifdef CPP_PHYS
+      CALL Init_interface_dyn_phys
+#endif
+      CALL barrier
+
       CALL set_bands
-#ifdef CPP_PHYS
-      CALL Init_interface_dyn_phys
-#endif
-      CALL barrier
-
       if (mpi_rank==0) call WriteBands
       call SetDistrib(jj_Nb_Caldyn)
@@ -207,9 +177,9 @@
 c$OMP END PARALLEL
 
-#ifdef CPP_PHYS
-c$OMP PARALLEL
-      call InitComgeomphy
-c$OMP END PARALLEL 
-#endif
+!#ifdef CPP_PHYS
+!c$OMP PARALLEL
+!      call InitComgeomphy ! now done in iniphysiq
+!c$OMP END PARALLEL 
+!#endif
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -431,33 +401,12 @@
 c   Initialisation de la physique :
 c   -------------------------------
-      IF (call_iniphys.and.(iflag_phys==1.or.iflag_phys>=100)) THEN
-         latfi(1)=rlatu(1)
-         lonfi(1)=0.
-         zcufi(1) = cu(1)
-         zcvfi(1) = cv(1)
-         DO j=2,jjm
-            DO i=1,iim
-               latfi((j-2)*iim+1+i)= rlatu(j)
-               lonfi((j-2)*iim+1+i)= rlonv(i)
-               zcufi((j-2)*iim+1+i) = cu((j-1)*iip1+i)
-               zcvfi((j-2)*iim+1+i) = cv((j-1)*iip1+i)
-            ENDDO
-         ENDDO
-         latfi(ngridmx)= rlatu(jjp1)
-         lonfi(ngridmx)= 0.
-         zcufi(ngridmx) = cu(ip1jm+1)
-         zcvfi(ngridmx) = cv(ip1jm-iim)
-         CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,aire,airefi)
-
-         WRITE(lunout,*)
-     .       'GCM: WARNING!!! vitesse verticale nulle dans la physique'
+      IF ((iflag_phys==1).or.(iflag_phys>=100)) THEN
 ! Physics:
 #ifdef CPP_PHYS
-         CALL iniphysiq(ngridmx,llm,daysec,day_ini,dtphys/nsplit_phys,
-     &                latfi,lonfi,airefi,zcufi,zcvfi,rad,g,r,cpp,
+         CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys,
+     &                rlatu,rlonv,aire,cu,cv,rad,g,r,cpp,
      &                iflag_phys)
 #endif
-         call_iniphys=.false.
-      ENDIF ! of IF (call_iniphys.and.(iflag_phys==1.or.iflag_phys>=100))
+      ENDIF ! of IF ((iflag_phys==1).or.(iflag_phys>=100))
 
 
@@ -550,6 +499,5 @@
 
 c$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logici/,/logicl/)
-      CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
-     .              time_0)
+      CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,time_0)
 c$OMP END PARALLEL
 
Index: LMDZ5/branches/testing/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/leapfrog_p.F	(revision 2220)
+++ LMDZ5/branches/testing/libf/dyn3dpar/leapfrog_p.F	(revision 2258)
@@ -5,6 +5,5 @@
 c
 
-      SUBROUTINE leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
-     &                    time_0)
+      SUBROUTINE leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,time_0)
 
       use exner_hyb_m, only: exner_hyb
@@ -77,6 +76,4 @@
 #include "academic.h"
       
-      INTEGER,PARAMETER :: longcles = 20
-      REAL,INTENT(IN) :: clesphy0( longcles ) ! not used
       REAL,INTENT(IN) :: time_0 ! not used
 
@@ -831,6 +828,5 @@
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $               du,dv,dteta,dq,
-     $               flxw,
-     $               clesphy0, dufi,dvfi,dtetafi,dqfi,dpfi  )
+     $               flxw, dufi,dvfi,dtetafi,dqfi,dpfi  )
 !        CALL FTRACE_REGION_END("calfis")
         ijb=ij_begin
Index: LMDZ5/branches/testing/libf/phydev/iniphysiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phydev/iniphysiq.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phydev/iniphysiq.F90	(revision 2258)
@@ -2,26 +2,30 @@
 ! $Id: iniphysiq.F 1403 2010-07-01 09:02:53Z fairhead $
 !
-SUBROUTINE iniphysiq(ngrid, nlayer, punjours, pdayref, ptimestep, plat, plon, &
-    parea, pcu, pcv, prad, pg, pr, pcpp, iflag_phys)
-  USE dimphy, ONLY: klev
-  USE mod_grid_phy_lmdz, ONLY: klon_glo
-  USE mod_phys_lmdz_para, ONLY: klon_omp, klon_omp_begin, klon_omp_end, &
-    klon_mpi_begin
-  USE comgeomphy, ONLY: airephy, cuphy, cvphy, rlond, rlatd
-  USE comcstphy, ONLY: rradius, rg, rr, rcpp
+SUBROUTINE iniphysiq(iim,jjm,nlayer,punjours, pdayref,ptimestep,         &
+                     rlatu,rlonv,aire,cu,cv,                             &
+                     prad,pg,pr,pcpp,iflag_phys)
+  USE dimphy, ONLY: klev ! number of atmospheric levels
+  USE mod_grid_phy_lmdz, ONLY: klon_glo ! number of atmospheric columns
+                                        ! (on full grid)
+  USE mod_phys_lmdz_para, ONLY: klon_omp, & ! number of columns (on local omp grid)
+                                klon_omp_begin, & ! start index of local omp subgrid
+                                klon_omp_end, & ! end index of local omp subgrid
+                                klon_mpi_begin ! start indes of columns (on local mpi grid)
+  USE comgeomphy, ONLY: initcomgeomphy, &
+                        airephy, & ! physics grid area (m2)
+                        cuphy, & ! cu coeff. (u_covariant = cu * u)
+                        cvphy, & ! cv coeff. (v_covariant = cv * v)
+                        rlond, & ! longitudes
+                        rlatd ! latitudes
+  USE comcstphy, ONLY: rradius, & ! planet radius (m)
+                       rr, & ! recuced gas constant: R/molar mass of atm
+                       rg, & ! gravity
+                       rcpp  ! specific heat of the atmosphere
   USE phyaqua_mod, ONLY: iniaqua
   IMPLICIT NONE
   !
   !=======================================================================
-  !
   !   Initialisation of the physical constants and some positional and 
   !   geometrical arrays for the physics
-  !
-  !
-  !    ngrid                 Size of the horizontal grid.
-  !                          All internal loops are performed on that grid.
-  !    nlayer                Number of vertical layers.
-  !    pdayref               Day of reference for the simulation
-  !
   !=======================================================================
  
@@ -34,19 +38,30 @@
   REAL,INTENT(IN) :: pcpp ! specific heat Cp
   REAL,INTENT(IN) :: punjours ! length (in s) of a standard day
-  INTEGER,INTENT(IN) :: ngrid ! number of horizontal grid points in the physics
-  INTEGER,INTENT(IN) :: nlayer ! number of atmospheric layers
-  REAL,INTENT(IN) :: plat(ngrid) ! latitudes of the physics grid
-  REAL,INTENT(IN) :: plon(ngrid) ! longitudes of the physics grid
-  REAL,INTENT(IN) :: parea(klon_glo) ! area (m2)
-  REAL,INTENT(IN) :: pcu(klon_glo) ! cu coeff. (u_covariant = cu * u)
-  REAL,INTENT(IN) :: pcv(klon_glo) ! cv coeff. (v_covariant = cv * v)
-  INTEGER,INTENT(IN) :: pdayref ! reference day of for the simulation
+  INTEGER, INTENT (IN) :: nlayer ! number of atmospheric layers
+  INTEGER, INTENT (IN) :: iim ! number of atmospheric coulumns along longitudes
+  INTEGER, INTENT (IN) :: jjm  ! number of atompsheric columns along latitudes
+  REAL, INTENT (IN) :: rlatu(jjm+1) ! latitudes of the physics grid
+  REAL, INTENT (IN) :: rlonv(iim+1) ! longitudes of the physics grid
+  REAL, INTENT (IN) :: aire(iim+1,jjm+1) ! area of the dynamics grid (m2)
+  REAL, INTENT (IN) :: cu((iim+1)*(jjm+1)) ! cu coeff. (u_covariant = cu * u)
+  REAL, INTENT (IN) :: cv((iim+1)*jjm) ! cv coeff. (v_covariant = cv * v)
+  INTEGER, INTENT (IN) :: pdayref ! reference day of for the simulation
   REAL,INTENT(IN) :: ptimestep !physics time step (s)
   INTEGER,INTENT(IN) :: iflag_phys ! type of physics to be called
 
   INTEGER :: ibegin,iend,offset
+  INTEGER :: i,j
   CHARACTER (LEN=20) :: modname='iniphysiq'
   CHARACTER (LEN=80) :: abort_message
- 
+  REAL :: total_area_phy, total_area_dyn
+
+
+  ! global array, on full physics grid:
+  REAL,ALLOCATABLE :: latfi(:)
+  REAL,ALLOCATABLE :: lonfi(:)
+  REAL,ALLOCATABLE :: cufi(:)
+  REAL,ALLOCATABLE :: cvfi(:)
+  REAL,ALLOCATABLE :: airefi(:)
+
   IF (nlayer.NE.klev) THEN
     WRITE(lunout,*) 'STOP in ',trim(modname)
@@ -58,22 +73,59 @@
   ENDIF
 
-  IF (ngrid.NE.klon_glo) THEN
-    WRITE(lunout,*) 'STOP in ',trim(modname)
-    WRITE(lunout,*) 'Problem with dimensions :'
-    WRITE(lunout,*) 'ngrid     = ',ngrid
-    WRITE(lunout,*) 'klon   = ',klon_glo
-    abort_message = ''
-    CALL abort_gcm (modname,abort_message,1)
-  ENDIF
+  !call init_phys_lmdz(iim,jjm+1,llm,1,(/(jjm-1)*iim+2/))
+  
+  ! Generate global arrays on full physics grid
+  ALLOCATE(latfi(klon_glo),lonfi(klon_glo),cufi(klon_glo),cvfi(klon_glo))
+  ALLOCATE(airefi(klon_glo))
 
-  !$OMP PARALLEL PRIVATE(ibegin,iend) &
-  !$OMP          SHARED(parea,pcu,pcv,plon,plat)
-      
+    ! North pole
+    latfi(1)=rlatu(1)
+    lonfi(1)=0.
+    cufi(1) = cu(1)
+    cvfi(1) = cv(1)
+    DO j=2,jjm
+      DO i=1,iim
+        latfi((j-2)*iim+1+i)= rlatu(j)
+        lonfi((j-2)*iim+1+i)= rlonv(i)
+        cufi((j-2)*iim+1+i) = cu((j-1)*iim+1+i)
+        cvfi((j-2)*iim+1+i) = cv((j-1)*iim+1+i)
+      ENDDO
+    ENDDO
+    ! South pole
+    latfi(klon_glo)= rlatu(jjm+1)
+    lonfi(klon_glo)= 0.
+    cufi(klon_glo) = cu((iim+1)*jjm+1)
+    cvfi(klon_glo) = cv((iim+1)*jjm-iim)
+
+    ! build airefi(), mesh area on physics grid
+    CALL gr_dyn_fi(1,iim+1,jjm+1,klon_glo,aire,airefi)
+    ! Poles are single points on physics grid
+    airefi(1)=sum(aire(1:iim,1))
+    airefi(klon_glo)=sum(aire(1:iim,jjm+1))
+
+    ! Sanity check: do total planet area match between physics and dynamics?
+    total_area_dyn=sum(aire(1:iim,1:jjm+1))
+    total_area_phy=sum(airefi(1:klon_glo))
+    IF (total_area_dyn/=total_area_phy) THEN
+      WRITE (lunout, *) 'iniphysiq: planet total surface discrepancy !!!'
+      WRITE (lunout, *) '     in the dynamics total_area_dyn=', total_area_dyn
+      WRITE (lunout, *) '  but in the physics total_area_phy=', total_area_phy
+      IF (abs(total_area_dyn-total_area_phy)>0.00001*total_area_dyn) THEN
+        ! stop here if the relative difference is more than 0.001%
+        abort_message = 'planet total surface discrepancy'
+        CALL abort_gcm(modname, abort_message, 1)
+      ENDIF
+    ENDIF
+
+!$OMP PARALLEL 
+  ! Now generate local lon/lat/cu/cv/area arrays
+  CALL initcomgeomphy
+
   offset = klon_mpi_begin - 1
-  airephy(1:klon_omp) = parea(offset+klon_omp_begin:offset+klon_omp_end)
-  cuphy(1:klon_omp) = pcu(offset+klon_omp_begin:offset+klon_omp_end)
-  cvphy(1:klon_omp) = pcv(offset+klon_omp_begin:offset+klon_omp_end)
-  rlond(1:klon_omp) = plon(offset+klon_omp_begin:offset+klon_omp_end)
-  rlatd(1:klon_omp) = plat(offset+klon_omp_begin:offset+klon_omp_end)
+  airephy(1:klon_omp) = airefi(offset+klon_omp_begin:offset+klon_omp_end)
+  cuphy(1:klon_omp) = cufi(offset+klon_omp_begin:offset+klon_omp_end)
+  cvphy(1:klon_omp) = cvfi(offset+klon_omp_begin:offset+klon_omp_end)
+  rlond(1:klon_omp) = lonfi(offset+klon_omp_begin:offset+klon_omp_end)
+  rlatd(1:klon_omp) = latfi(offset+klon_omp_begin:offset+klon_omp_end)
 
   ! copy some fundamental parameters to physics
@@ -83,12 +135,12 @@
   rcpp=pcpp
 
-  !$OMP END PARALLEL
+!$OMP END PARALLEL
 
   ! Additional initializations for aquaplanets 
-  !$OMP PARALLEL
+!$OMP PARALLEL
   IF (iflag_phys>=100) THEN
     CALL iniaqua(klon_omp,rlatd,rlond,iflag_phys)
   ENDIF
-  !$OMP END PARALLEL
+!$OMP END PARALLEL
 
 END SUBROUTINE iniphysiq
Index: LMDZ5/branches/testing/libf/phydev/physiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 2258)
@@ -4,5 +4,5 @@
       SUBROUTINE physiq (nlon,nlev, &
      &            debut,lafin,jD_cur, jH_cur,pdtphys, &
-     &            paprs,pplay,pphi,pphis,presnivs,clesphy0, &
+     &            paprs,pplay,pphi,pphis,presnivs, &
      &            u,v,t,qx, &
      &            flxmass_w, &
@@ -45,6 +45,4 @@
       real,intent(in) :: pphis(klon) ! surface geopotential
       real,intent(in) :: presnivs(klev) ! pseudo-pressure (Pa) of mid-layers
-      integer,parameter :: longcles=20
-      real,intent(in) :: clesphy0(longcles) ! Not used
       real,intent(in) :: u(klon,klev) ! eastward zonal wind (m/s)
       real,intent(in) :: v(klon,klev) ! northward meridional wind (m/s)
Index: LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2258)
@@ -1,3 +1,3 @@
-SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text)
+SUBROUTINE add_pbl_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy)
   ! ======================================================================
   ! Ajoute les tendances de couche limite, soit determinees par la
@@ -20,4 +20,5 @@
   REAL hqturb_gcssold(llm)
   REAL dtime_frcg
+  INTEGER abortphy
   LOGICAL turb_fcg_gcssold
   COMMON /turb_forcing/dtime_frcg, hthturb_gcssold, hqturb_gcssold, &
@@ -46,7 +47,7 @@
     PRINT *, ' add_pbl_tend, zzdt ', zzdt
     PRINT *, ' add_pbl_tend, zzdq ', zzdq
-    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, zdqi, paprs, text)
+    CALL add_phys_tend(zdu, zdv, zzdt, zzdq, zdql, zdqi, paprs, text,abortphy)
   ELSE
-    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text)
+    CALL add_phys_tend(zdu, zdv, zdt, zdq, zdql, zdqi, paprs, text,abortphy)
   END IF
 
Index: LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2258)
@@ -2,5 +2,5 @@
 ! $Id$
 !
-SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,zdqi,paprs,text)
+SUBROUTINE add_phys_tend (zdu,zdv,zdt,zdq,zdql,zdqi,paprs,text,abortphy)
 !======================================================================
 ! Ajoute les tendances des variables physiques aux variables 
@@ -28,4 +28,5 @@
 REAL paprs(klon,klev+1)
 CHARACTER*(*) text
+INTEGER abortphy
 
 ! Local :
@@ -52,5 +53,8 @@
 ! Initialisations
 
-debug_level=10
+      IF (abortphy==1) RETURN ! on n ajoute pas les tendance si le modele
+                              ! a deja plante.
+
+     debug_level=10
      if (first) then
         itap=0
@@ -230,5 +234,23 @@
 ENDIF
 
-      CALL hgardfou(t_seri,ftsol,text)
+
+!======================================================================
+! Contrôle des min/max pour arrêt du modèle
+! Si le modele est en mode abortphy, on retire les tendances qu'on
+! vient d'ajouter. Pas exactement parce qu'on ne tient pas compte des
+! seuils.
+!======================================================================
+
+      CALL hgardfou(t_seri,ftsol,text,abortphy) 
+      IF (abortphy==1) THEN
+        Print*,'ERROR ABORT hgardfou dans ',text
+        u_seri(:,:)=u_seri(:,:)-zdu(:,:)
+        v_seri(:,:)=v_seri(:,:)-zdv(:,:)
+        ql_seri(:,:)=ql_seri(:,:)-zdql(:,:)
+        qs_seri(:,:)=qs_seri(:,:)-zdqi(:,:)
+      ENDIF
+
+
+
       RETURN
       END
Index: LMDZ5/branches/testing/libf/phylmd/calcratqs.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calcratqs.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/calcratqs.F90	(revision 2258)
@@ -1,4 +1,4 @@
 SUBROUTINE calcratqs(klon,klev,prt_level,lunout,       &
-           iflag_ratqs,iflag_con,iflag_cldth,pdtphys, &
+           iflag_ratqs,iflag_con,iflag_cld_th,pdtphys, &
            ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,   &
            ptconv,ptconvth,clwcon0th, rnebcon0th,      &
@@ -19,5 +19,5 @@
 ! Input
 integer,intent(in) :: klon,klev,prt_level,lunout
-integer,intent(in) :: iflag_con,iflag_cldth,iflag_ratqs
+integer,intent(in) :: iflag_con,iflag_cld_th,iflag_ratqs
 real,intent(in) :: pdtphys,ratqsbas,ratqshaut,fact_cldcon,tau_ratqs
 real, dimension(klon,klev+1),intent(in) :: paprs
@@ -43,5 +43,5 @@
 !   ----------------
 !   on ecrase le tableau ratqsc calcule par clouds_gno
-      if (iflag_cldth.eq.1) then
+      if (iflag_cld_th.eq.1) then
          do k=1,klev
          do i=1,klon
@@ -58,5 +58,5 @@
 !  par nversion de la fonction log normale
 !-----------------------------------------------------------------------
-      else if (iflag_cldth.eq.4) then
+      else if (iflag_cld_th.eq.4) then
          ptconvth(:,:)=.false.
          ratqsc(:,:)=0.
@@ -136,5 +136,5 @@
 !  -----------
 
-      if (iflag_cldth.eq.1 .or.iflag_cldth.eq.2.or.iflag_cldth.eq.4) then
+      if (iflag_cld_th.eq.1 .or.iflag_cld_th.eq.2.or.iflag_cld_th.eq.4) then
 
 ! On ajoute une constante au ratqsc*2 pour tenir compte de 
@@ -165,5 +165,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          ratqs(:,:)=max(ratqs(:,:),ratqss(:,:))
-      else if (iflag_cldth<=6) then
+      else if (iflag_cld_th<=6) then
 !   on ne prend que le ratqs stable pour fisrtilp
          ratqs(:,:)=ratqss(:,:)
@@ -174,5 +174,5 @@
              do i=1,klon
                 if (ratqsc(i,k).gt.1.e-10) then
-                   ratqs(i,k)=ratqs(i,k)*zfratqs2+(iflag_cldth/100.)*ratqsc(i,k)*(1.-zfratqs2)
+                   ratqs(i,k)=ratqs(i,k)*zfratqs2+(iflag_cld_th/100.)*ratqsc(i,k)*(1.-zfratqs2)
                 endif
                 ratqs(i,k)=min(ratqs(i,k)*zfratqs1+ratqss(i,k)*(1.-zfratqs1),0.5)
Index: LMDZ5/branches/testing/libf/phylmd/cdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cdrag.F90	(revision 2258)
+++ LMDZ5/branches/testing/libf/phylmd/cdrag.F90	(revision 2258)
@@ -0,0 +1,225 @@
+!
+!$Id: cdrag.F90 ???? 2015-??-?? ??:??:??Z ? $
+!
+ SUBROUTINE cdrag( knon,  nsrf,   &
+     speed, t1,    q1,    zgeop1, &
+     psol,  tsurf, qsurf, rugos,  &
+     pcfm,  pcfh,  zri,   pref )
+
+  USE dimphy
+  USE indice_sol_mod
+  IMPLICIT NONE
+! ================================================================= c
+!
+! Objet : calcul des cdrags pour le moment (pcfm) et 
+!         les flux de chaleur sensible et latente (pcfh).   
+!
+! Modified histroy: 
+!   27-Jan-2014: richardson number inconsistant between
+!   coefcdrag.F90 and clcdrag.F90, Fuxing WANG wrote this subroutine
+!   by merging coefcdrag and clcdrag.
+!
+! References:
+!   Louis, J. F., 1979: A parametric model of vertical eddy fluxes in the
+!     atmosphere. Boundary-Layer Meteorology. 01/1979; 17(2):187-202. 
+!   Louis, J. F., Tiedtke, M. and Geleyn, J. F., 1982: `A short history of the
+!     operational PBL parametrization at ECMWF'. Workshop on boundary layer
+!     parametrization, November 1981, ECMWF, Reading, England. 
+!     Page: 19. Equations in Table 1.
+!   Anton Beljaars. May 1992. The parametrization of the planetary boundary layer.  
+!     European Centre for Medium-Range Weather Forecasts.
+!     Equations: 110-113. Page 40.
+!   Miller,M.J., A.C.M.Beljaars, T.N.Palmer. 1992. The sensitivity of the ECMWF
+!     model to the parameterization of evaporation from the tropical oceans. J.
+!     Climate, 5:418-434.
+!
+! ================================================================= c
+!
+! knon----input-I- nombre de points pour un type de surface
+! nsrf----input-I- indice pour le type de surface; voir indicesol.h
+! speed---input-R- module du vent au 1er niveau du modele
+! t1------input-R- temperature de l'air au 1er niveau du modele
+! q1------input-R- humidite de l'air au 1er niveau du modele
+! zgeop---input-R- geopotentiel au 1er niveau du modele
+! psol----input-R- pression au sol
+! tsurf---input-R- temperature de l'air a la surface 
+! qsurf---input-R- humidite de l'air a la surface
+! rugos---input-R- rugosite
+!! u1, v1 are removed, speed is used. Fuxing WANG, 04/03/2015,
+!! u1------input-R- vent zonal au 1er niveau du modele
+!! v1------input-R- vent meridien au 1er niveau du modele
+!
+! pcfm---output-R- cdrag pour le moment 
+! pcfh---output-R- cdrag pour les flux de chaleur latente et sensible
+! zri----output-R- Richardson number
+! pref---output-R- pression au niveau zgeop/RG
+!
+! Parameters: 
+! ckap-----Karman constant
+! cb,cc,cd-parameters in Louis et al., 1982
+! ================================================================= c
+!
+!
+! Parametres d'entree
+!***************************************************************** 
+  INTEGER, INTENT(IN)                      :: knon, nsrf
+  REAL, DIMENSION(klon), INTENT(IN)        :: speed ! module du vent au 1er niveau du modele
+  REAL, DIMENSION(klon), INTENT(IN)        :: zgeop1! geopotentiel au 1er niveau du modele
+  REAL, DIMENSION(klon), INTENT(IN)        :: psol  ! pression au sol
+  REAL, DIMENSION(klon), INTENT(IN)        :: t1    ! temperature at 1st level
+  REAL, DIMENSION(klon), INTENT(IN)        :: q1    ! humidity at 1st level
+  REAL, DIMENSION(klon), INTENT(IN)        :: tsurf ! Surface temperature (K)
+  REAL, DIMENSION(klon), INTENT(IN)        :: qsurf ! Surface humidity (Kg/Kg)
+  REAL, DIMENSION(klon), INTENT(IN)        :: rugos ! Rugosity at surface (m) 
+!  paprs, pplay u1, v1: to be deleted
+!  they were in the old clcdrag. Fuxing WANG, 04/03/2015
+!  REAL, DIMENSION(klon,klev+1), INTENT(IN) :: paprs
+!  REAL, DIMENSION(klon,klev), INTENT(IN)   :: pplay
+!  REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1
+
+! Parametres de sortie
+!******************************************************************
+  REAL, DIMENSION(klon), INTENT(OUT)       :: pcfm  ! Drag coefficient for heat flux
+  REAL, DIMENSION(klon), INTENT(OUT)       :: pcfh  ! Drag coefficient for momentum
+  REAL, DIMENSION(klon), INTENT(OUT)       :: zri   ! Richardson number
+  REAL, DIMENSION(klon), INTENT(OUT)       :: pref  ! Pression au niveau zgeop/RG
+
+! Parametres local
+  INTEGER                                  :: ng_q1    ! Number of grids that q1 < 0.0
+  INTEGER                                  :: ng_qsurf ! Number of grids that qsurf < 0.0
+!  zgeop1, psol: to be deleted, they are inputs now. Fuxing WANG, 04/03/2015
+!  REAL, DIMENSION(klon)                    :: zgeop1! geopotentiel au 1er niveau du modele
+!  REAL, DIMENSION(klon)                    :: psol  ! pression au sol
+!
+! ================================================================= c
+!
+  INCLUDE "YOMCST.h"
+  INCLUDE "YOETHF.h"
+!  INCLUDE "indicesol.h"
+  INCLUDE "clesphys.h"
+  INCLUDE "iniprint.h"
+!
+! Quelques constantes et options:
+!!$PB      REAL, PARAMETER :: ckap=0.35, cb=5.0, cc=5.0, cd=5.0, cepdu2=(0.1)**2
+  REAL, PARAMETER :: CKAP=0.40, CB=5.0, CC=5.0, CD=5.0, CEPDU2 = (0.1)**2
+!
+! Variables locales :
+  INTEGER               :: i
+  REAL                  :: zdu2, ztsolv
+  REAL                  :: ztvd, zscf
+  REAL                  :: zucf, zcr
+  REAL                  :: friv, frih
+  REAL, DIMENSION(klon) :: zcfm1, zcfm2 ! Drag coefficient for momentum
+  REAL, DIMENSION(klon) :: zcfh1, zcfh2 ! Drag coefficient for heat flux
+  LOGICAL, PARAMETER    :: zxli=.FALSE. ! calcul des cdrags selon Laurent Li
+  REAL, DIMENSION(klon) :: zcdn         ! Drag coefficient in neutral conditions
+!
+! Fonctions thermodynamiques et fonctions d'instabilite
+  REAL                  :: fsta, fins, x
+  fsta(x) = 1.0 / (1.0+10.0*x*(1+8.0*x))
+  fins(x) = SQRT(1.0-18.0*x)
+
+! ================================================================= c
+! Fuxing WANG, 04/03/2015, delete the calculation of zgeop1 
+! (le geopotentiel du premier couche de modele).
+! zgeop1 is an input ivariable in this subroutine.
+!  DO i = 1, knon
+!     zgeop1(i) = RD * t1(i) / (0.5*(paprs(i,1)+pplay(i,1))) &
+!          * (paprs(i,1)-pplay(i,1))
+!  END DO
+! ================================================================= c
+!
+! Fuxing WANG, 04/03/2015
+! To check if there are negative q1, qsurf values.
+  ng_q1 = 0     ! Initialization
+  ng_qsurf = 0  ! Initialization
+  DO i = 1, knon
+     IF (q1(i).LT.0.0)     ng_q1 = ng_q1 + 1
+     IF (qsurf(i).LT.0.0)  ng_qsurf = ng_qsurf + 1
+  ENDDO
+  IF (ng_q1.GT.0) THEN
+      WRITE(lunout,*)" *** Warning: Negative q1(humidity at 1st level) values in cdrag.F90 !"
+      WRITE(lunout,*)" The total number of the grids is: ", ng_q1
+      WRITE(lunout,*)" The negative q1 is set to zero "
+!      abort_message="voir ci-dessus"
+!      CALL abort_gcm(modname,abort_message,1)
+  ENDIF
+  IF (ng_qsurf.GT.0) THEN
+      WRITE(lunout,*)" *** Warning: Negative qsurf(humidity at surface) values in cdrag.F90 !"
+      WRITE(lunout,*)" The total number of the grids is: ", ng_qsurf
+      WRITE(lunout,*)" The negative qsurf is set to zero "
+!      abort_message="voir ci-dessus"
+!      CALL abort_gcm(modname,abort_message,1)
+  ENDIF
+
+! Calculer le frottement au sol (Cdrag)
+  DO i = 1, knon
+!------------------------------------------------------------
+! u1, v1 are replaced by speed. Fuxing WANG, 04/03/2015,
+!     zdu2 = MAX(CEPDU2,u1(i)**2+v1(i)**2)
+!------------------------------------------------------------
+     zdu2 = MAX(CEPDU2, speed(i)**2)
+!     psol(i) = paprs(i,1)
+     pref(i) = EXP(LOG(psol(i)) - zgeop1(i)/(RD*t1(i)* &
+                 (1.+ RETV * max(q1(i),0.0))))  ! negative q1 set to zero
+!------------ the old calculations in clcdrag----------------
+!     ztsolv = tsurf(i) * (1.0+RETV*qsurf(i)) 
+!     ztvd = (t1(i)+zgeop1(i)/RCPD/(1.+RVTMP2*q1(i))) &
+!          *(1.+RETV*q1(i)) 
+!------------------------------------------------------------
+! Fuxing WANG, 04/03/2015, in this revised version, 
+! the negative qsurf and q1 are set to zero (as in coefcdrag)
+     ztsolv = tsurf(i) * (1.0+RETV*max(qsurf(i),0.0)) ! negative qsurf set to zero
+     ztvd = (t1(i)+zgeop1(i)/RCPD/(1.+RVTMP2*q1(i))) &
+          *(1.+RETV*max(q1(i),0.0)) ! negative q1 set to zero
+     zri(i) = zgeop1(i)*(ztvd-ztsolv)/(zdu2*ztvd)
+     zcdn(i) = (CKAP/LOG(1.+zgeop1(i)/(RG*rugos(i))))**2
+
+     IF (zri(i) .GT. 0.) THEN      ! situation stable
+        zri(i) = MIN(20.,zri(i))
+        IF (.NOT.zxli) THEN
+           zscf = SQRT(1.+CD*ABS(zri(i)))
+           friv = AMAX1(1. / (1.+2.*CB*zri(i)/ZSCF), f_ri_cd_min)
+           zcfm1(i) = zcdn(i) * friv
+           frih = AMAX1(1./ (1.+3.*CB*zri(i)*ZSCF), f_ri_cd_min )
+!!$ PB     zcfh1(i) = zcdn(i) * frih
+!!$ PB     zcfh1(i) = f_cdrag_stable * zcdn(i) * frih
+           zcfh1(i) = f_cdrag_ter * zcdn(i) * frih
+           IF(nsrf.EQ.is_oce) zcfh1(i) = f_cdrag_oce * zcdn(i) * frih
+!!$ PB
+           pcfm(i) = zcfm1(i)
+           pcfh(i) = zcfh1(i)
+        ELSE
+           pcfm(i) = zcdn(i)* fsta(zri(i))
+           pcfh(i) = zcdn(i)* fsta(zri(i))
+        ENDIF
+     ELSE                          ! situation instable
+        IF (.NOT.zxli) THEN
+           zucf = 1./(1.+3.0*CB*CC*zcdn(i)*SQRT(ABS(zri(i)) &
+                *(1.0+zgeop1(i)/(RG*rugos(i)))))
+           zcfm2(i) = zcdn(i)*amax1((1.-2.0*CB*zri(i)*zucf),f_ri_cd_min)
+!!$ PB     zcfh2(i) = zcdn(i)*amax1((1.-3.0*cb*zri(i)*zucf),f_ri_cd_min)
+           zcfh2(i) = f_cdrag_ter*zcdn(i)*amax1((1.-3.0*CB*zri(i)*zucf),f_ri_cd_min)
+           pcfm(i) = zcfm2(i)
+           pcfh(i) = zcfh2(i)
+        ELSE
+           pcfm(i) = zcdn(i)* fins(zri(i))
+           pcfh(i) = zcdn(i)* fins(zri(i))
+        ENDIF
+! cdrah sur l'ocean cf. Miller et al. (1992)
+        zcr = (0.0016/(zcdn(i)*SQRT(zdu2)))*ABS(ztvd-ztsolv)**(1./3.)
+        IF(nsrf.EQ.is_oce) pcfh(i) =f_cdrag_oce* zcdn(i)*(1.0+zcr**1.25)**(1./1.25)
+     ENDIF
+  END DO
+
+! ================================================================= c
+     
+  ! IM cf JLD : on seuille cdrag_m et cdrag_h
+  IF (nsrf == is_oce) THEN
+     DO i=1,knon
+        pcfm(i)=MIN(pcfm(i),cdmmax)
+        pcfh(i)=MIN(pcfh(i),cdhmax)
+     END DO
+  END IF
+
+END SUBROUTINE cdrag
